#include "gssapiP_krb5.h"

GSS_DLLIMP OM_uint32 KRB5_CALLCONV 
gss_krb5_ccache_name(minor_status, name, out_name)
	OM_uint32 *minor_status;
	const char *name;
	const char **out_name;
{
	krb5_context context;
	krb5_error_code retval;
	OM_uint32 foo_stat;
	static char *oldname = NULL;
	const char *tmpname = NULL;

	if (GSS_ERROR(kg_get_context(minor_status, &context)))
		return (GSS_S_FAILURE);

	if (out_name) {
		if (oldname != NULL)
			free(oldname);
		/*
		 * Save copy of previous default ccname, since
		 * cc_set_default_name will free it and we don't want
		 * to hang on to a pointer to freed memory.
		 */
		tmpname = krb5_cc_default_name(context);
		oldname = malloc(strlen(tmpname) + 1);
		if (oldname == NULL)
			return GSS_S_FAILURE;
		strcpy(oldname, tmpname);
		*out_name = oldname;
	}

	retval = krb5_cc_set_default_name(context, name);
	if (retval) {
		*minor_status = retval;
		return GSS_S_FAILURE;
	}
	kg_release_defcred(&foo_stat);
	return GSS_S_COMPLETE;
}
		

	

